Package org.springframework.jca.support

# Class LocalConnectionFactoryBean

java.lang.Object
org.springframework.jca.support.LocalConnectionFactoryBean

All Implemented Interfaces:
  `org.springframework.beans.factory.FactoryBean<Object>`, `org.springframework.beans.factory.InitializingBean`

public class LocalConnectionFactoryBean extends Object implements org.springframework.beans.factory.FactoryBean<Object>, org.springframework.beans.factory.InitializingBean
`FactoryBean` that creates a local JCA connection factory in "non-managed" mode (as defined by the Java Connector Architecture specification). This is a direct alternative to a `JndiObjectFactoryBean` definition that obtains a connection factory handle from a Jakarta EE server's naming environment.

The type of the connection factory is dependent on the actual connector: the connector can either expose its native API (such as a JDBC `DataSource` or a JMS `jakarta.jms.ConnectionFactory`) or follow the standard Common Client Interface (CCI), as defined by the JCA spec. The exposed interface in the CCI case is `ConnectionFactory`.

In order to use this FactoryBean, you must specify the connector's `"managedConnectionFactory"` (usually configured as separate JavaBean), which will be used to create the actual connection factory reference as exposed to the application. Optionally, you can also specify a `"connectionManager"`, in order to use a custom ConnectionManager instead of the connector's default.

NOTE: In non-managed mode, a connector is not deployed on an application server, or more specifically not interacting with an application server. Consequently, it cannot use a Jakarta EE server's system contracts: connection management, transaction management, and security management. A custom ConnectionManager implementation has to be used for applying those services in conjunction with a standalone transaction coordinator etc.

The connector will use a local ConnectionManager (included in the connector) by default, which cannot participate in global transactions due to the lack of XA enlistment. You need to specify an XA-capable ConnectionManager in order to make the connector interact with an XA transaction coordinator. Alternatively, simply use the native local transaction facilities of the exposed API (for example, CCI local transactions), or use a corresponding implementation of Spring's PlatformTransactionManager SPI to drive local transactions.

Since:
  1.2
Author:
  Juergen Hoeller
See Also:
  - `setManagedConnectionFactory(jakarta.resource.spi.ManagedConnectionFactory)`
  - `setConnectionManager(jakarta.resource.spi.ConnectionManager)`
  - `ConnectionFactory`
  - `Connection.getLocalTransaction()`

## Field Summary

### Fields inherited from interface org.springframework.beans.factory.FactoryBean

`OBJECT_TYPE_ATTRIBUTE`

## Constructor Summary

Constructors
Constructor
Description
`LocalConnectionFactoryBean()`

## Method Summary

Modifier and Type
Method
Description
`void`
`afterPropertiesSet()`
`Object`
`getObject()`
`Class<?>`
`getObjectType()`
`boolean`
`isSingleton()`
`void`
`setConnectionManager(ConnectionManager connectionManager)`
Set the JCA ConnectionManager that should be used to create the desired connection factory.
`void`
`setManagedConnectionFactory(ManagedConnectionFactory managedConnectionFactory)`
Set the JCA ManagerConnectionFactory that should be used to create the desired connection factory.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### LocalConnectionFactoryBean

public LocalConnectionFactoryBean()

## Method Details

### setManagedConnectionFactory

public void setManagedConnectionFactory(ManagedConnectionFactory managedConnectionFactory)
Set the JCA ManagerConnectionFactory that should be used to create the desired connection factory.

The ManagerConnectionFactory will usually be set up as separate bean (potentially as inner bean), populated with JavaBean properties: a ManagerConnectionFactory is encouraged to follow the JavaBean pattern by the JCA specification, analogous to a JDBC DataSource and a JPA EntityManagerFactory.

Note that the ManagerConnectionFactory implementation might expect a reference to its JCA 1.7 ResourceAdapter, expressed through the `ResourceAdapterAssociation` interface. Simply inject the corresponding ResourceAdapter instance into its "resourceAdapter" bean property in this case, before passing the ManagerConnectionFactory into this LocalConnectionFactoryBean.

See Also:
  - `ManagedConnectionFactory.createConnectionFactory()`

### setConnectionManager

public void setConnectionManager(ConnectionManager connectionManager)
Set the JCA ConnectionManager that should be used to create the desired connection factory.

A ConnectionManager implementation for local usage is often included with a JCA connector. Such an included ConnectionManager might be set as default, with no need to explicitly specify one.

See Also:
  - `ManagedConnectionFactory.createConnectionFactory(jakarta.resource.spi.ConnectionManager)`

### afterPropertiesSet

public void afterPropertiesSet() throws ResourceException

Specified by:
  `afterPropertiesSet` in interface `org.springframework.beans.factory.InitializingBean`
Throws:
  `ResourceException`

### getObject

@Nullable public Object getObject()

Specified by:
  `getObject` in interface `org.springframework.beans.factory.FactoryBean<Object>`

### getObjectType

@Nullable public Class<?> getObjectType()

Specified by:
  `getObjectType` in interface `org.springframework.beans.factory.FactoryBean<Object>`

### isSingleton

public boolean isSingleton()

Specified by:
  `isSingleton` in interface `org.springframework.beans.factory.FactoryBean<Object>`